local Layer = class('Layer')

function Layer:initialize(name, width, height, definition)
	barrack.check({name, width, height, definition}, {'string', 'number', 'number', 'definition'})

	self.name = name
	self.definition = definition
	self.contents = {}
end

function Layer:draw()
	local xOffset = self._grid.x
	local yOffset = self._grid.y
	for x in pairs(self.contents) do
		for y in pairs(self.contents[x]) do
			local xDraw = (x-1) * self._grid.tileSize
			local yDraw = (y-1) * self._grid.tileSize
			if self.contents[x][y].draw then
				self.contents[x][y]:draw(xOffset + xDraw, yOffset + yDraw)
			end
		end
	end
end

function Layer:insert(content, x, y)
	barrack.check({content, x, y}, {self.definition, 'number', 'number'})

	zArray.set(self.contents, x, y, content)
end

return Layer
