local Piece = class('Piece')
Piece.rules = {}
Piece.selected = nil

function Piece:initialize(color, grid)
	self.sprite = love.graphics.newImage('resource/whitePawn.png')
	self.grid = grid
end

function Piece:draw(x, y, r)
	if self.grid._scene.selected.piece == self then
		love.graphics.setColor(45, 200, 45, 128)
		love.graphics.rectangle('fill', x, y, r, r)
		love.graphics.setColor(45, 45, 200, 128)

		local x1, y1 = self.grid:getPos(self)
		for x2=1, 8 do
			for y2=1, 8 do
				if self:validMove(x1, y1, x2, y2) then
					love.graphics.rectangle('fill', (x2-1)*r, (y2-1)*r, r, r)
				end
			end
		end
	end
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.draw(self.sprite, x, y)
end

function Piece:move(x2, y2)
	local x1, y1 = self.grid:getPos(self)

	if self:validMove(x1, y1, x2, y2) then
		self.grid:insert(nil, x1, y1)
		self.grid:insert(self, x2, y2)
		self.moved = true
		return true
	end
end

function Piece:isFriendly(piece)
	if piece then
		if piece.color == self.color then
			return true
		else
			return false
		end
	end
end

return Piece
