local Bishop = class('Bishop', Piece)

function Bishop:initialize(color, grid)
	Piece.initialize(self, color, grid)

	if color == 'white' then
		self.sprite = love.graphics.newImage('resource/whiteBishop.png')
	elseif color == 'black' then
		self.sprite = love.graphics.newImage('resource/blackBishop.png')
	end

	self.color = color
end

function Bishop:validMove(x1, y1, x2, y2)
	local destCell = self.grid:check(x2, y2)
	local xDistance = math.abs(x1 - x2)
	local yDistance = math.abs(y1 - y2)

	if xDistance == yDistance then
		for i=1, xDistance-1 do
			local x, y = zMath.toward(x1, x2, i), zMath.toward(y1, y2, i)
			local cell = self.grid:check(x, y)
			if cell ~= nil then
				return false
			end
		end
		if not self:isFriendly(self.grid:check(x2, y2)) then
			return true
		end
	end
end

return Bishop
