local scene = Scene:new()
scene.selected = {piece=nil, x=nil, y=nil}
scene.turn = 'white'

function scene:initialize()
	self.board = love.graphics.newImage('resource/board.png')
    self.grid = scene:newInstance(Grid, {8, 8, 96})
    require('script/setupBoard')(self.grid)
end

function scene:mousepressed(x, y, button)
	local piece, x, y = self.grid:mousepressed(x, y, button)

	if self.selected.piece == nil then
		if piece and piece.color == self.turn then
			self.selected = {
				piece = piece,
				x = x,
				y = y,
			}
		end
	else
		if self.selected.piece:move(x, y) == true then
			self:endTurn()
		end
		self.selected = {}
	end

    scene:exec('mouse', 'mousepressed', x, y, button)
end

function scene:keypressed(key)
    scene:exec('Grid', 'keypressed', key)
end

function scene:keyreleased(key)
    scene:exec('keyboard', 'keyreleased', key)
end

function scene:update(dt)
    scene:exec('update', 'update', dt)
    scene:exec('keyboard', 'keyboard')
end

function scene:draw()
	love.graphics.draw(self.board, 0, 0)
    scene:exec('draw', 'draw')

    self.grid:draw(0, 0, 96)
end

function scene:endTurn()
	if self.turn == 'black' then
		self.turn = 'white'
	elseif self.turn == 'white' then
		self.turn = 'black'
	end
end

return scene
